#!/usr/bin/python
# -*-coding:UTF-8-*-#
import sys
import string
import os
import pwd
import time
import memcache
from getIndicationInfo import *
from pywbem import *


def ErrorPage(ErrorCode):
    if ErrorCode == 1:     
    	ErrTitle = "URL Error" 
    	ErrComment = "The CGI-BIN needs a valid argument!"
    elif ErrorCode == 2: 
    	ErrTitle = "File Error" 
    	ErrComment = "File not found!"
    elif ErrorCode == 3:
        ErrTitle = "URL Error" 
  	ErrComment = "There is an error in the referenced url address!"
    elif ErrorCode == 4:
	ErrTitle = "URL Error" 
   	ErrComment = "The SubApp accessed is not valid!"
    elif ErrorCode == 5:
        ErrTitle = "HPSMH Error"
        ErrComment = "User HPSMH was not found! Check the packages integrity."
    elif ErrorCode == 6:
        ErrTitle = "HPSMH Error"
        ErrComment = "This Page must be access by user hpsmh!"
    else:
      	ErrTitle = "Unknown Error"
   	ErrComment = "An Unknown error ocurred!"

    print '''Content-type: text/html\n\n
	<script>\n
	 <!-- \n
	 Hewlett-Packard Development Company, L.P. The information \n
	 contained herein is subject to change without notice.\n
	 -->\n
	 <html>
	 <head> \n
	 <link rel='stylesheet' type='text/css' href='/css/default.css'>\n
	 <link rel='stylesheet' type='text/css' href='/css/blue_theme.css' />\n
	 <script language='JavaScript' type='text/javascript' src='/js/ComponentsLibrary.js'></script>\n
	 <script language='JavaScript' type='text/javascript' src='/js/Common.js'></script>\n
	 </head>\n
	 <body>\n
	 <script>\n'''
    print "var title='%s';\n" % ErrTitle
    print '''
	 var imgLogo='/images/themes/blue/logo_hp_smallmasthead.gif';\n
	 var picMasthead='/images/smallmasthead.jpg' ;\n
	 var helpurl='/help/WBEMServer/SoftwareVersionInformation.html'; \n
	 Smallmasthead(imgLogo, title, picMasthead, helpurl);\n
	 </script>\n
	 <h1 align='center' class='pageTitle'> '''
    print  ErrComment
    print '''&nbsp;&nbsp;&nbsp;&nbsp;<img src='/images/Software.jpg' alt='Software' align='middle' width='50' height='50'></h1>\n
	 <br>\n
	 <script language='JavaScript' type='text/javascript' src='/js/footer.js'></script>\n
	 </body>\n
	 </html>\n'''

"""
Choose the SMX_SELLogEntry instance ID format
For low end Integrity the instance ID is it's staring with 0x000000x0 
For high end Integrity the instance ID is it's staring with 0x0000000x 
Where x starts at zero and increments by 16 each time
"""
def ValidateInstanceIDFormat(wbemCli):
	sleIn = CIMInstanceName('SMX_SELLogEntry',namespace='root/hpq', keybindings={'InstanceID': 'HPQ:0x00000001'})
  	try:
    		wbemCli.GetInstance(sleIn)
    		return 1
  	except CIMError, arg:
    		return 0

"""
Get Instance List for SMX_SELLogEntry
Input: pageNum is the page number
Input: wbemCli is the pywbem WBEMConnection instance
"""
def GetSLEInstanceList(pageNum,wbemCli):
  	sleInstanceList = []
  	slin = CIMInstanceName('SMX_SELRecordLog', namespace='root/hpq',keybindings={'InstanceID': 'HPQ:SMX_SELRecordLog:1'})
  	sli = wbemCli.GetInstance(slin)
  	recordNum = sli['CurrentNumberOfRecords']
  	maxPageNum = recordNum/10
  	intStartIdx = pageNum*10
  	if pageNum < maxPageNum:
    		intEndIndx = intStartIdx + 10
  	else:
    		intEndIndx = intStartIdx + recordNum%10
  	for i in range(intStartIdx, intEndIndx):
    		strInstanceID = 'HPQ:0x'
    		strTmpHex = hex(i+1)
    		strTmpHex = strTmpHex[2:]
    		if ValidateInstanceIDFormat(wbemCli) == 1:
      			zeroCounter = 8 - len(strTmpHex)
      			for i in range(0,zeroCounter):
        			strInstanceID = strInstanceID + '0'
      			strInstanceID = strInstanceID + strTmpHex  
    		else:
      			zeroCounter = 7 - len(strTmpHex)
      			for i in range(0,zeroCounter):
        			strInstanceID = strInstanceID + '0'
      			strInstanceID = strInstanceID + strTmpHex
      			strInstanceID = strInstanceID + '0'   
    		rec = CIMInstanceName('SMX_SELLogEntry',namespace='root/hpq', keybindings={'InstanceID': '%s' % strInstanceID })
    		seleInstance = wbemCli.GetInstance(rec)
    		sleInstanceList.append(seleInstance)
  	return sleInstanceList

"""
Get Instance List for SMX_IMLLogEntry
For ProLiant Server the instance ID is it's staring with 0,and increments by 1
"""
def GetILEInstanceList(pageNum,wbemCli):
	ileInstanceList = []
	ilin = CIMInstanceName('SMX_IMLRecordLog', {'InstanceID': 'HPQ:SMX_IMLRecordLog:1'})
  	ili = wbemCli.GetInstance(slin)
  	recordNum = ili['CurrentNumberOfRecords']
  	maxPageNum = recordNum/10
  	intStartIdx = pageNum*10
  	if (pageNum < maxPageNum):
    		intEndIndx = intStartIdx + 10
  	else:
    		intEndIndx = intStartIdx + recordNum%10   
	for i in range(intStartIdx, intEndIndx):
 		rec = CIMInstanceName('SMX_IMLLogEntry',namespace='root/hpq', keybindings={'InstanceID': 'HPQ:SMX_IMLLogEntry:%d' % i}) 
		imleInstance = wbemCli.GetInstance(rec)
    		ileInstanceList.append(imleInstance)
	return ileInstanceList  

def processTestIndication(Type,wbemCli):
    if Type == 1:
	tmpType = 101
    elif Type == 2:
	tmpType = 102
    elif Type == 3:
	tmpType = 103
    try:
   	insts = wbemCli.EnumerateInstanceNames('SMX_ComputerSystem','root/hpq')
	inst = insts[0]
	stat = wbemCli.InvokeMethod('SendTestIndication', inst, TestIndicationID=Uint32(tmpType))
	return 1
    except pywbem.CIMError, arg:
	return 0
    
def getIndication(wbemCli):
    return 1
"""
Process State Propagation filter
Input Param:
  spfType: enum type, 1 means power; 2 means mp; 3 means ethernet  
  Idx: int type, for the instance idx
  bStat:bool type, the state to change, 0 means False, 1 means True
  wbemCli: pywbem.WBEMConnection Type
Return Value: 1 means sucess 0 means fail  
"""
def processSPF(spfType,Idx,bStat,wbemCli):
    if spfType == 1:
	className = 'SMX_MemberOfPowerCollection'
    elif spfType == 2:
	className = 'SMX_MPMemberOfCollection'
    elif spfType == 3:
	className = 'SMX_EthernetMemberOfCollection'
    elif spfType == 4:
        className = 'SMX_FCHBAFCPortGroupSystemSpecific'
    try:
   	instNames = wbemCli.EnumerateInstanceNames(className,'root/hpq')
	instName = instNames[Idx]
	inst = wbemCli.GetInstance(instName)
	tmpItems = inst.items()
	if spfType == 4:
	    if bStat == 0:
                   tmpItems[1] = (u'Included', False)
            else:
                   tmpItems[1] = (u'Included', True)

	else:
	    if bStat == 0:
		    tmpItems[0] = (u'Included', False)
	    else:
		    tmpItems[0] = (u'Included', True)
	inst.update_existing(inst,tmpItems)
	inst.path = instName
	stat = wbemCli.ModifyInstance(inst)
	return 1
    except pywbem.CIMError, arg:
	return 0

def main(argv = None):
    """main function."""

    # Split argv list up in to a part
    # and a part to be consumed by unittest.py.
    if argv is None:
        argv = sys.argv
    webapp_root = "/opt/hp/hpsmh/data/htdocs"
    mc = memcache.Client(['localhost:11211'],debug=0)
    ErrorCode = 0
    SubApp = ["WBEMServer","WBEMStorage","WBEMNetwork"]
    #queryChar example: file=cpu.dhtm&SubApp=WBEMServer
    queryChar  = os.getenv("QUERY_STRING")
    if queryChar == None:
      ErrorCode = 1
      ErrorPage(ErrorCode)
      sys.exit(1)
    
    queryCharList = string.rsplit(queryChar,'&')
    queryCharDict = dict()
    for tmpquery in queryCharList:
    	try:
    		tmpList = string.rsplit(tmpquery, '=')
    		queryCharDict[tmpList[0]] = tmpList[1]
  	except:
    		continue
    try:
    	inputSubapp = queryCharDict['SubApp']
	os.stat(webapp_root + '/' + inputSubapp)
    except ValueError:
  	ErrorCode = 3 
  	ErrorPage(ErrorCode)
	sys.exit(1)
    try:
    	filePathName = webapp_root + '/' + inputSubapp + '/' + queryCharDict['file']
	myfile = file(filePathName, 'r')
    except:
    	ErrorCode = 2
	ErrorPage(ErrorCode)
	sys.exit(1)  
    try: 
	sPwd = pwd.getpwnam('hpsmh')
    except KeyError:
	ErrorCode = 5
    	ErrorPage(ErrorCode)   
	sys.exit(1)
    uid  = os.getuid()
    if uid != sPwd[2]:
        ErrorCode = 6
        ErrorPage(ErrorCode)
        sys.exit(1)
    tiResult = 0 
    inResult = 0
    print 'Content-type: text/html\n\n'    
    lines = myfile.readlines()
    cli = None
    for dir in ["/var/run/tog-pegasus/socket/cimxml.socket", "/var/run/tog-pegasus/cimxml.socket"]:
        try:
        	os.stat(dir)
        	cli = WBEMConnection(dir)
        except :
        	continue

    if cli == None:
    	cli = SFCBUDSConnection()
      
    if cli == None:
    	print 'Cannot establish a local connection!'
    	sys.exit(2)
     
    if str(queryCharDict['file']) == 'SelLog.dhtm' or str(queryCharDict['file']) == 'ImlLog.dhtm':
	pageNum = int(queryCharDict['PageNum'])

    if str(queryCharDict['file']) == 'TestIndication.dhtm':
    	if int(queryCharDict['PrimaryKeyValue']) in [1,2,3]:
                tiResult = processTestIndication(int(queryCharDict['PrimaryKeyValue']),cli)
                
    if str(queryCharDict['file']) == 'GetIndication.dhtm':
        inResult = getIndication(cli)

    if (queryCharDict.has_key('spfIdx') and queryCharDict.has_key('spfValue')):
	if str(queryCharDict['file']) == 'powerSupply.dhtm':
		spfType = 1
	elif str(queryCharDict['file']) == 'mp.dhtm':
		spfType = 2
	elif str(queryCharDict['file']) == 'ShowSinglePortDetails.dhtm':
		spfType = 3
	elif str(queryCharDict['file']) == 'ControllerFCHBA.dhtm':
                spfType = 4
	processSPF(spfType,int(queryCharDict['spfIdx']),int(queryCharDict['spfValue']),cli)
    t1 = time.time()             
    for line in lines:
        line=line.split('\n')
        sline=line[0]
        try:
                nPos = sline.index('<')
        except ValueError:
		if tiResult == 1:
			tmpIndicationString = "var tmpLastSendIndication=" + str(queryCharDict['PrimaryKeyValue']) + ";"
			sline = sline.replace("var tmpLastSendIndication=null;", tmpIndicationString)
			sline = sline.replace("var tmpLastSendIndication=1;", tmpIndicationString)
			sline = sline.replace("var tmpLastSendIndication=2;", tmpIndicationString)
			sline = sline.replace("var tmpLastSendIndication=3;", tmpIndicationString)
        	elif inResult == 1:
            		if "smxIndication=" in sline:
				result = []
				i = 0
				sline = ''
                        	result = getIndicationInfo('/var/lib/hpshd/indications.db')
                        	print 'var smxIndication = new Array();'
                        	for line in result:
					print 'smxIndication[%s] = new Object();' % (str(i))
					for tmp in line:
						if str(tmp[0]) == 'RawData':
							continue
						print 'smxIndication[%s].%s = \"%s\";' % (str(i),str(tmp[0]),str(tmp[1]).replace("\"","\\\""))
					i += 1
		print sline
            	continue
        if nPos < len(line):
                if sline[nPos+1] == '#':
                        subStrStartPos = nPos + 3
                        nPos = sline.index('>')
                        if nPos < len(sline):
                                subStrEndPos = nPos
                                sQuery = sline[subStrStartPos:subStrEndPos]
                                space = sline.index('&')
                                sClassNamespace = sQuery[space+8:]
                                sClassName = sQuery[6:space-3]
				cacheInfo = mc.get(sClassName)
				if cacheInfo != None:
					if str(queryCharDict['file']) == 'serverhome.dhtm' and  sClassName == 'SMX_PCIDevice':
                                        	if cacheInfo == 'Overflow' or len(cacheInfo) > 100:
                                        		print 'SMX_PCIDevice = \'hasData\';'
						continue
					if 'Overflow' == cacheInfo:
						res = []
        					num = mc.get(sClassName+'0')
        					for mk in range(num):
							res.append(mc.get(sClassName + str(mk+1)))
                				print ''.join(res)
					else:
						#print 'alert(\''+sClassName+'\');'
						print cacheInfo
				else:
			#		print 'alert(\'3\');'
                                	try:
    						if str(queryCharDict['file']) == 'SelLog.dhtm' and sClassName == 'SMX_SELLogEntry':
                                        		cimInstances = GetSLEInstanceList(pageNum,cli)
    						elif str(queryCharDict['file']) == 'ImlLog.dhtm' and sClassName == 'SMX_IMLLogEntry':
                                        		cimInstances = GetILEInstanceList(pageNum,cli)
    						else:
                                        		cimInstances = cli.EnumerateInstances(sClassName,sClassNamespace)
						i = 0
                                        	print '%s = new Array();' % (cimInstances[0].classname)
                                        	for cimInstance in cimInstances:
                                                	print '%s[%s] = new Object();' % (cimInstance.classname,str(i))
                                                	for key, value in cimInstance.items():
                						tmpvalue = ''
                       						import __builtin__
                       						if __builtin__.type(value) == list:
                       							for a in value:
                       								if tmpvalue == '':
                       									tmpvalue = a
                       								else:
                       									tmpvalue = str(tmpvalue) + " " + str(a)
                       						else:
                       							tmpvalue = value
                       						tmpvalue = str(tmpvalue)
                       						if tmpvalue.find('"') > -1:
                       							tmpvalue = tmpvalue.replace('"','') 	
                       						if tmpvalue.find('\n') > -1:
                       							tmpvalue = tmpvalue.replace('\n',' ') 	
                       						print '%s[%s].%s = "%s";' % (cimInstance.classname,str(i),key, tmpvalue) 	
                                                	i=i+1
                                	except:
                                        	print '//Can not get data from Namespace:%s Class:%s\n' % (sClassNamespace,sClassName)
                                        	continue
                else:
                        print sline
                        continue
        else:
                 print sline
                 continue
    myfile.close()
    t2=time.time();
    #print 'alert('+str(t2-t1)+');'
    if tiResult == 1:
 	myfile = file(filePathName,'w')
	for iLines in range(0, len(lines)):
		lines[iLines] = lines[iLines].replace("var tmpLastSendIndication=null;", tmpIndicationString) 
		lines[iLines] = lines[iLines].replace("var tmpLastSendIndication=1;", tmpIndicationString) 
		lines[iLines] = lines[iLines].replace("var tmpLastSendIndication=2;", tmpIndicationString) 
		lines[iLines] = lines[iLines].replace("var tmpLastSendIndication=3;", tmpIndicationString) 
	myfile.writelines(lines)
	myfile.close()
	
    
          
if __name__ == "__main__":
    sys.exit(main())
