/*
 * Hewlett-Packard Development Company, L.P. The information 
 * contained herein is subject to change without notice.
 *
 *  $RCSfile: ipf_functions.js,v $
 *  $Author: sjaviel $
 *  $Revision: 1.2 $
 *  $Date: 2007-10-01 13:01:26 $
 *
 */

// tells if the system is cellular
// returns true for cellular systems or
// returns false otherwise
function isPartitionedSystem() {
	if (HP_ComputerSystemChassis[0].VendorEquipmentType.toUpperCase() == "CELLULAR") {
		//alert('isPartitionedSystem = true');
		return true;
	}
	//alert('isPartitionedSystem = false');
	return false;
}


// tells if the system is HPVM
// returns true for HPVM systems or
// returns false otherwise
function isHPVM(){
	if (HP_ComputerSystemChassis[0].VendorEquipmentType.toUpperCase() == "VIRTUAL-MACHINE") {
		return true;
	}
	return false;
}

// tells if is a Blade System
// returns true for Blade System or
// returns false otherwise
function isBladeSystem() {
	if (HP_ComputerSystemChassis[0].VendorEquipmentType.toUpperCase() == "BLADE") {
		return true;
	}
	return false;
}

// Received string CBHSS format string and returns an integer Cabinet value
function getCabinet(hexaParam){
	var a = hexToArray(hexaParam);
	return(parseInt(binToDeci(a[0])));
}

// Received string CBHSS format string and returns an integer Bay value
function getBay(hexaParam){
	var a = hexToArray(hexaParam);
	return(parseInt(binToDeci(a[1])));
}

// Received string CBHSS format string and returns an integer Chassis value
function getChassis(hexaParam){
	var a = hexToArray(hexaParam);
	return(parseInt(binToDeci(a[2])));
}

// Received string CBHSS format string and returns an integer Slot value
function getSlot(hexaParam){
	var a = hexToArray(hexaParam);
	return(parseInt(binToDeci(a[3])));
}


// Received string CBHSS format string and returns an array containing
// a byte in each position corresponding to the following CBHSS format:
// C=cab#, B=bay#, H=chassis#, SS=slot#.
// Sample: Value 0x 304 indicates cab0, bay 0, chassis 3, slot 4.
function hexToArray(hexaParam) 
{
	
	hexaValue = hexaParam.replace(/0x/,'');
	hexaValue = hexaToBin(hexaValue);	

	for(var i = hexaValue.length; i <= 32; i++) 
	{
		hexaValue = ('0' + hexaValue); 	
	}
	
	arrrayOfBytes = new Array();

	for(var i=0; i<4; i++) 
	{
		arrrayOfBytes[i] = hexaValue.substring(8*i, 8*(i+1)); 
	}
	
	return arrrayOfBytes;
}


// Converts a binary value to decimal
function binToDeci(num)
{
	res3 = 999;
	args = num;
	sdsf = args.substring(args.length-1,args.length) ;
	//document.second.binHex.value = sdsf;
	if(sdsf!=0 && sdsf != 1)
	{
		document.second.bin.value = args.substring(0,args.length-1) ;
		res3 = 1;

	}
	else
	{
		k =args.length-1;
		for(var i=0; i<args.length; i++)
		{
		 thisnum = args.substring(i,i+1) ;
		 var resd = Math.pow(2,k);
		 resd = resd*thisnum;
		k=k-1;
		 	if(res3 == 999)
			{
				res3=resd.toString();
			}
			else
			{
				res3=parseInt(res3)+parseInt(resd);
			}
		}
	}

	return res3;
}

function hexToBin(sd)
{
	//var sd = name.value;
	if(isHexNum(sd))
	{
		sd=sd.toLowerCase();
		var result = hexToDeci(sd)

		result = deciToBin(result)
		return(result);
	}
}

function isNum(args)
{
	args = args.toString();
	if (args.length == 0)
		return false;

	for (var i = 0;  i<args.length;  i++)
	{
		if (args.substring(i,i+1) < "0" || args.substring(i, i+1) > "9")
		{
			return false;
		}
	}

	return true;
}

function deciToBin(arg)
{
	res1 = 999;
	args = arg;
	while(args>1)
	{
		arg1 = parseInt(args/2);
		arg2 = args%2;
		args = arg1;
		//alert(arg1);
		//alert(arg2);

		if(res1 == 999)
		{
			res1=arg2.toString();
		}
		else
		{
				res1=arg2.toString()+res1.toString();
		}
	}
	if(args==1 && res1 != 999)
	{
		res1=args.toString()+res1.toString();
	}
	else if(args==0 && res1 == 999)
	{
		res1=0;
	}
	else if(res1 == 999)
	{
		res1=1;
	}

	var ll = res1.length;
	while(ll%4 != 0)
	{
		res1 = "0"+res1;
		ll = res1.length;
	}	

	return res1;
}

function getHexNum(num)
{
	ar1 = new Array('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15');
	ar2 = new Array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
	if(num > 15)
	{
		return num;
	}
	else
	{
		red = ar2[num];
		return red;
	}
}

function deciToHex(arg)
{
	res2 = 999;
	args = arg;
	while(args>15)
	{
		arg1=parseInt(args/16);
		arg2=args%16;
		arg2=getHexNum(arg2);
		args=arg1;

		if(res2 == 999)
		{
			res2=arg2.toString();
		}
		else
		{
			res2=arg2.toString()+res2.toString();
		}

	}
	if(args<16 && res2 != 999)
	{
		def = getHexNum(args);
		//document.first.deciBin.value = def;
		res2=def+res2.toString();
	}
	 else if(res2 == 999)
	{
		if(args < 16)
		{
			res2= getHexNum(args);
		}
		else
		{
			res2= 1;
		}
	}

	return res2;
}

function isHexNum(num)
{
	args=num;
	sdsf = args.substring(args.length-1,args.length) ;
	//document.third.hexBin.value = sdsf;
	lc = sdsf.toLowerCase()
	if( isNum(sdsf) || lc =='a' || lc =='b' || lc =='c' || lc =='d' || lc =='e' || lc =='f')
	{
	return true;
	}
	return false;
}

function hexToDeci(num)
{
	res4 = 999;
	args = num;
	//hexAr = new Array('1','2','3','4','5','6','7','8','9','a','b','c','d','e','f');

	k =args.length-1;
	for(var i=0; i<args.length; i++)
	{
	 	thisnum = args.substring(i,i+1) ;
	 	var resd = Math.pow(16,k);
		if(thisnum=='a')
			thisnum=10;
		else if(thisnum=='b')
			thisnum=11;
		else if(thisnum=='c')
			thisnum=12;
		else if(thisnum=='d')
			thisnum=13;
		else if(thisnum=='e')
			thisnum=14;
		else if(thisnum=='f')
			thisnum=15;
		 resd = resd*thisnum;
		 k=k-1;
		 if(res4 == 999)
			{
				res4=resd.toString();
			}
			else
			{
				res4=parseInt(res4)+parseInt(resd);
			}
	}

	return res4;
}
function getSocket(tag) {
	var temp = tag.split("Socket ");
	if (temp.length == 1)
		return socket = "N/A";
	else
		return temp[1].charAt(0);
}
function getSlot(tag) {
	var temp = tag.split("Slot ");
	if (temp.length == 1)
		return socket = "N/A";
	else
		return temp[1].charAt(0);
}